#include <GL/glut.h>
#include "GameObj.h"
#include "GameObjTimed.h"
#include "Bullet.h"
#include "BulletFireBall.h"
#include "Ship.h"
#include "Ship3D.h"

Ship3D::Ship3D(char * filename, char * texturename)
{
	bonus=false;
	M.Open(filename);
	M.Normalize();
	if(texturename)
		{
			M.SetTexture(texturename);
			M.SetMapMode(Mesh::PLANAR);
		}
  M.Smooth();
	B.r=3;
}

int Ship3D::Draw()
{
	int nt=0;
	static float flamelen=5;
	glPushMatrix();
		glTranslate(p);
		glRotatef(angle,0,0,1);
		if(av>0) glRotatef(-30,1,0,0);
		if(av<0) glRotatef( 30,1,0,0);
		glPushMatrix();
			glScalef(8,8,8);
			//glRotatef(-90,0,0,1);
			glRotatef(180,1,0,0);
			glColor3f(.7,1,.7);
        glDisable(GL_CULL_FACE);
				nt+=M.Draw();
				glEnable(GL_CULL_FACE);
		glPopMatrix();
		glTranslatef(-2,0,0);
		glDisable(GL_LIGHTING);
		if(lthrust)
		{
			glBegin(GL_TRIANGLE_FAN);
			glColor3f(.95,.9,.6);
			glVertex3f(-1, -6,  0);
			glVertex3f(0,  -10,  0);
			glVertex3f(1, -6,  0);
			glVertex3f(0,  -4,  0);
			glEnd();
			nt+=2;
		}
		if(rthrust)
		{
			glBegin(GL_TRIANGLE_FAN);
			glColor3f(.95,.9,.6);
			glVertex3f(1, 6,  0);
			glVertex3f(0,  10,  0);
			glVertex3f(-1,  6,  0);
			glVertex3f(0,  5,  0);
			glEnd();
			nt+=2;
		}
		if(thrust)
		{
			if(flamelen==12) flamelen=10;
			else flamelen=12;
			glBegin(GL_TRIANGLE_FAN);
			glColor3f(.95,.9,.6);
			glVertex3f(-5,0,0);
			glColor3f(.95,.5,.1);
			glVertex3f(-2, 0,  0);
			glVertex3f(-3, 1.7,0);
			glVertex3f(-4, 2,  0);
			glVertex3f(-7, 1, 0);
			glColor3f(.6,.3,.1);
			glVertex3f(-flamelen,0,0);
			glColor3f(.95,.5,.1);
			glVertex3f(-7,-1,  0);
			glVertex3f(-4,-2,  0);
			glVertex3f(-3,-1.7,0);
			glVertex3f(-2, 0,  0);
			glEnd();
			nt+=8;
		}
		glEnable(GL_LIGHTING);
	glPopMatrix();
	return nt;
}

void Ship3D::Shoot(list<Bullet *> &LB){
	if(bonus){
			if(ActiveBullet+2 < MaxBullet()){
				ActiveBullet+=3;
				Bullet *bb;
				angle-=10;
				bb =new Bullet(p - RotateZ(Point3f(0,+2,0),float((angle+10)*M_PI/180.0f)),angle,v+VDir()*30);
				LB.push_back(bb);
				angle+=20;
				bb =new Bullet(p - RotateZ(Point3f(0,-2,0),float((angle-10)*M_PI/180.0f)),angle,v+VDir()*30);
				LB.push_back(bb);
				angle-=10;
				bb =new Bullet(p,angle,v+VDir()*30);
				LB.push_back(bb);
			}
	}
	else {
			if(ActiveBullet < MaxBullet()){
				ActiveBullet++;
				Bullet *bb;
				bb =new Bullet(p,angle,v+VDir()*30);
				LB.push_back(bb);
			}
	}
}
