#ifndef __IUF_SHIP3D
#define __IUF_SHIP3D
#include "Triangle.h"

/** This class represent a ship with a 3d shape. 
The 3D shape is loaded from a file by the constructor.
The Draw function and the constructor have been rewritten.

	
Version History {\small 
\begin{itemize}
\item 0.2 First Release.
\item 0.2s
Changed the default shape of the ship, 
Added side flame when side thrust is active
\end{itemize}
}

*/
class Ship3D: public Ship
{
 public:
/** The constructor now also load the ship mesh */
	 Ship3D(char *filename ="data/astro.raw",char *texturename=0);
/** Function has been rewritten to handle 3D. 
The ship is drawn by simply invoking the \Ref{Mesh::Draw}() 
member function of the \Ref{Mesh} Class. This function has to
setup the proper transformation to put the ship in the standard 
size and orientation (the loaded model was headed along y axis 
instead of x axis and was too small). An additional X axis rotation 
has been added to simulate the side-rolling of the ship 
when turning left and right.
The flame has also changed: it is done with a triangle fan shading
from inner red to outer yellow. It also changes its lenght.
Added side flames and used the Normalize function to set the loaded shape to the right position.
	 */
	int Draw();
	
	/** The maximum number of bullet now is 30 instead of 10 
	This has been copied from TriShip.
	*/
	int MaxBullet() {if(bonus) return 30;
	else return 10;};
	
	/** Shoot a new bullet triple. 
	It creates the three new bullets and return them in a list 
	This has been copied from TriShip. */
	void Shoot(list<Bullet *> &LB);
	
	/** The Shape of the ship. 
	*/
	Mesh M;
};
#endif